package com.fufan.mtsaas.modules.sysmgr.syuser.dao;

import com.fufan.mtsaas.modules.sysmgr.syuser.model.SYusergroup;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 用户角色表(SYusergroup)表数据库访问层
 *
 * @author makejava
 * @since 2025-03-27 14:12:33
 */
public interface SYusergroupDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    SYusergroup queryById(Long id);

    /**
     * 查询指定行数据
     *
     * @param SYusergroup 查询条件
     * @param pageable    分页对象
     * @return 对象列表
     */
    List<SYusergroup> queryAllByLimit(SYusergroup SYusergroup, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param SYusergroup 查询条件
     * @return 总行数
     */
    long count(SYusergroup SYusergroup);

    /**
     * 新增数据
     *
     * @param SYusergroup 实例对象
     * @return 影响行数
     */
    int insert(SYusergroup SYusergroup);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<SYusergroup> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<SYusergroup> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<SYusergroup> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<SYusergroup> entities);

    /**
     * 修改数据
     *
     * @param SYusergroup 实例对象
     * @return 影响行数
     */
    int update(SYusergroup SYusergroup);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Long id);

    //通过userId删除
    int deleteByUserId(Long userId);

    //通过userGroupId删除
    int deleteByUserGroupId(Long userGroupId);

}

